.\"	$OpenBSD: putc.3,v 1.11 2013/06/05 03:39:23 tedu Exp $
.\"
.\" Copyright (c) 1990, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" This code is derived from software contributed to Berkeley by
.\" Chris Torek and the American National Standards Committee X3,
.\" on Information Processing Systems.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd $Mdocdate: June 5 2013 $
.Dt PUTC 3
.Os
.Sh NAME
.Nm fputc ,
.Nm putc ,
.Nm putchar ,
.Nm putw
.Nd output a character or word to a stream
.Sh SYNOPSIS
.In stdio.h
.Ft int
.Fn fputc "int c" "FILE *stream"
.Ft int
.Fn putc "int c" "FILE *stream"
.Ft int
.Fn putchar "int c"
.Ft int
.Fn putw "int w" "FILE *stream"
.Sh DESCRIPTION
The
.Fn fputc
function writes the character
.Fa c
(converted to an
.Li unsigned char )
to the output stream pointed to by
.Fa stream .
.Pp
.Fn putc
acts essentially identically to
.Fn fputc ,
but is a macro that expands in-line.
It may evaluate
.Fa stream
more than once, so arguments given to
.Fn putc
should not be expressions with potential side effects.
.Pp
.Fn putchar
is identical to
.Fn putc
with an output stream of
.Em stdout .
.Pp
The
.Fn putw
function writes the specified
.Li int
.Fa w
to the named output
.Fa stream .
.Sh RETURN VALUES
The functions
.Fn fputc ,
.Fn putc ,
and
.Fn putchar
return the character written.
If an error occurs, the value
.Dv EOF
is returned and the global variable
.Va errno
is set to indicate the error.
The
.Fn putw
function returns 0 on success;
.Dv EOF
is returned if a write error occurs,
or if an attempt is made to write a read-only stream.
The global variable
.Va errno
may be set to indicate the error.
.Sh ERRORS
The function
.Fn putw
may also fail and set
.Va errno
for any of the errors specified for the routines
.Xr write 2
or
.Xr realloc 3 .
.Sh SEE ALSO
.Xr ferror 3 ,
.Xr fopen 3 ,
.Xr getc 3 ,
.Xr stdio 3
.Sh STANDARDS
The functions
.Fn fputc ,
.Fn putc ,
and
.Fn putchar ,
conform to
.St -ansiC .
A function
.Fn putw
function appeared in
.At v6 .
.Sh BUGS
Since the size and byte order of an
.Li int
may vary from one machine to another,
.Fn putw
is not recommended for portable applications.
